var assign = require('object-assign');

var AttendeeConstants = require('../constants/AttendeeConstants');
var UserConstants = require('../constants/UserConstants');

module.exports = function(state = {}, action) {
	switch (action.type) {
		case AttendeeConstants.ATTENDEES_FETCHED:
			var attendees = {};
			for (var i = 0; i < action.attendees.length; i++) {
				var attendee = action.attendees[i];
				attendees[attendee.AttendeeId] = attendee;
			}
			return attendees;
		case AttendeeConstants.ATTENDEE_CREATED:
			var attendee = action.attendee;
			var attendees = assign({}, state, {
				[attendee.AttendeeId]: attendee
			});
			return attendees;
		case AttendeeConstants.ATTENDEE_REMOVED:
			var attendees = assign({}, state);
			delete attendees[action.attendeeId];
			return attendees;
		case UserConstants.USER_LOGGEDOUT:
			return {};
		default:
			return state;
	}
};
